unit ScrollBarImpl;

interface

uses Windows, ComObj, ActiveX, DBTables, DB, SysUtils, ScrollBars_TLB, AQTEST_TLB,
  Classes, Messages;

type
  TScrollBar = class(TAutoIntfObject, IScrollBars)
  private
  public
    constructor Create;
    destructor Destroy; override;
    procedure ScrollBy(HWND: Integer; HPOS: Integer; VPOS: Integer); safecall;
  end;

var
  FSCROLLBARS: IDispatch;

function GetModuleTypeLib: ITypeLib;


implementation

{$IFDEF Codesite}
uses CSIntf;
{$ENDIF}

function GetModuleTypeLib: ITypeLib;

  function GetModuleFileName: string;
  var
    Buffer: array[0..261] of Char;
  begin
    SetString(Result, Buffer, Windows.GetModuleFileName(HInstance,
      Buffer, SizeOf(Buffer)));
  end;

  function LoadTypeLibrary(const ModuleName: string): ITypeLib;
  begin
    OleCheck(LoadTypeLib(PWideChar(WideString(ModuleName)), Result));
  end;

begin
  Result := LoadTypeLibrary(GetModuleFileName);
end;


constructor TScrollBar.Create();
begin
  inherited Create(GetModuleTypeLib,IScrollBars);
end;

destructor TScrollBar.Destroy;
begin
  inherited;
end;


procedure TScrollBar.ScrollBy(HWND: Integer; HPOS: Integer; VPOS: Integer);
var
 si: TScrollInfo;

 procedure GetScroll(Dir:Integer);
 begin
   FillChar( si, sizeof( si ), 0 ); // always a good idea
   with si do begin
   cbSize := sizeof(si);
   fMask := SIF_ALL;
   end;
   GetScrollInfo( HWND, Dir, si );
 end;

begin

 GetScroll(SB_HORZ);

 while si.nPos < HPOS do
 begin
   SendMessage(HWND,WM_HSCROLL,SB_LINEDOWN,	0);
   GetScroll(SB_HORZ);
 end;    // while

 while si.nPos > HPOS do
 begin
   SendMessage(HWND,WM_HSCROLL,SB_LINEUP,	0);
   GetScroll(SB_HORZ);
 end;    // while




 GetScroll(SB_VERT);

 while si.nPos < VPOS do
 begin
   SendMessage(HWND,WM_VSCROLL,SB_LINEDOWN,	0);
   GetScroll(SB_VERT);
 end;    // while

 while si.nPos > VPOS do
 begin
   SendMessage(HWND,WM_VSCROLL,SB_LINEUP,	0);
   GetScroll(SB_VERT);
 end;    // while

// with si do begin
//   nPOS := VPOS;
//   nTrackPos := VPOS;
// end;
// SetScrollInfo( HWND, SB_VERT, si, TRUE );


// SetScrollPos(HWND,SB_HORZ, HPOS, TRUE);
// SetScrollPos(HWND,SB_VERT, VPOS, TRUE);
end;


end.

